//
// Yet Another Ping Of Death Bot Configuration Tool
// Copyright (c) 2005, by Dmitry Zhukov. All Rights Reserved.
//
// P.S.: I HATE BORLANDC C++ BUILDER IDE! :)
//

#include <vcl.h>
#include <windows.h>
#include <stdio.h>
#include <assert.h>

#include "genclass.h"
#include "confparse.h"
#include "yapbconfig.h"

// very simple eh?
CConfig::CConfig (string sInputFile)
{
   FILE *pIn = fopen (sInputFile, "r");

   if (pIn == NULL)
   {
      MessageBox (GetActiveWindow (), "Couldn't find required podbot.cfg, in current folder. Please install me Correctly!", "FATAL ERROR", MB_ICONSTOP);
      ExitProcess (TRUE);
   }

   char szLine[256];

   while (fgets (szLine, 255, pIn) != NULL)
      m_kFileBuffer.AddItem (szLine);

   fclose (pIn);
}

void CConfig::SetString (string sName, string sValue)
{
   for (int i = 0; i < m_kFileBuffer.Size (); i++)
   {
      if (strncmp (m_kFileBuffer[i], sName, sName.Length () - 1) == 0)
      {
         vector <string> kPair = m_kFileBuffer[i]->Split (' ');
         string sResult = kPair[0] + " " + sValue + "\n";

         m_kFileBuffer.Remove (i);
         m_kFileBuffer.Insert (i, sResult);

         break;
      }
   }
   return;
}

string CConfig::GetString (string sName)
{
   for (int i = 0; i < m_kFileBuffer.Size (); i++)
   {
      if (strncmp (m_kFileBuffer[i]->GetString (), sName->GetString (), sName->Length ()) == 0)
      {
         vector <string> kPair = m_kFileBuffer[i]->Split (' ');
         
         if (!kPair[1].IsEmpty ())
            return kPair[1].Trim ();

         return "666";
      }
   }
   return "666";
}

void CConfig::WriteOutput (bool bCleanOne, string sConfigName)
{
   FILE *pOut = fopen (sConfigName, "w");

   if (bCleanOne)
   {
      fprintf (pOut, "//\n");
      fprintf (pOut, "// Generated by YaPB Config Tool\n");
      fprintf (pOut, "// Copyright (C) 2005, by Dmitry Zhukov\n");
      fprintf (pOut, "//\n\n");
   }

   for (int i = 0; i < m_kFileBuffer.Size (); i++)
   {
      if (bCleanOne && (((m_kFileBuffer[i][0] == '/') && (m_kFileBuffer[i][1] == '/')) || (m_kFileBuffer[i][0] == '\n')))
         continue;

      fprintf (pOut, m_kFileBuffer[i]);
   }
   fclose (pOut);
}

CSkillConfig::CSkillConfig (void)
{
   FILE *pIn = fopen ("botskill.cfg", "r");

   if (pIn == NULL)
   {
      MessageBox (GetActiveWindow (), "Couldn't find required botskill.cfg, in current folder. Please install me Correctly!", "FATAL ERROR", MB_ICONSTOP);
      ExitProcess (TRUE);
   }

   char szLine[256];
   int iState = 0;

   while (fgets (szLine, 255, pIn) != NULL)
   {
      if ((szLine[0] == '\n') || (szLine[0] == ' ') || (szLine[0] == '#'))
         continue;

      string sParam = string (szLine).Split (' ')[0];
      string sValue = string (szLine).Split (' ')[1];

      if (strcmp (SKILL_MIN_DELAY, sParam) == 0)
         m_kSkillData[iState].fMinDelay = sValue->GetFloat () * 100.0;
      else if (strcmp (SKILL_MAX_DELAY, sParam) == 0)
         m_kSkillData[iState].fMaxDelay = sValue->GetFloat () * 100.0;

      else if (strcmp (SKILL_AIM_OFFS_X, sParam) == 0)
         m_kSkillData[iState].fAimOffsY = sValue->GetFloat ();
      else if (strcmp (SKILL_AIM_OFFS_Y, sParam) == 0)
         m_kSkillData[iState].fAimOffsX = sValue->GetFloat ();
      else if (strcmp (SKILL_AIM_OFFS_Z, sParam) == 0)
         m_kSkillData[iState].fAimOffsZ = sValue->GetFloat ();

      else if (strcmp (SKILL_HEADSHOT_ALLOW, sParam) == 0)
         m_kSkillData[iState].fHeadshot = sValue->GetFloat ();
      else if (strcmp (SKILL_HEARPROB, sParam) == 0)
         m_kSkillData[iState].fHearProb = sValue->GetFloat ();
      else if (strcmp (SKILL_SEENPROB, sParam) == 0)
      {
         m_kSkillData[iState].fSeenProb = sValue->GetFloat ();
         iState++;
      }
   }
   fclose (pIn);
}

void CSkillConfig::SetIDE (eSkl iSkl)
{
   Main->MaxReactScroll->Position = m_kSkillData[iSkl].fMaxDelay;
   Main->MinReactScroll->Position = m_kSkillData[iSkl].fMinDelay;

   Main->AimXScroll->Position = m_kSkillData[iSkl].fAimOffsX;
   Main->AimYScroll->Position = m_kSkillData[iSkl].fAimOffsY;
   Main->AimZScroll->Position = m_kSkillData[iSkl].fAimOffsZ;

   Main->HeadAimScroll->Position = m_kSkillData[iSkl].fHeadshot;
   Main->HeardScroll->Position = m_kSkillData[iSkl].fHearProb;
   Main->SeenScroll->Position = m_kSkillData[iSkl].fSeenProb;
}

void CSkillConfig::WriteConfig (void)
{
   FILE *pOut = fopen ("botskill.cfg", "w");

   fprintf (pOut, "# In this File you can tweak some of the POD-Bot\n");
   fprintf (pOut, "# Skill Settings\n");
   fprintf (pOut, "# As usual the \"#\" char starts a comment line\n");
   fprintf (pOut, "# NOTE: If you have inhumanturns turned on in\n");
   fprintf (pOut, "# podbot.cfg the turnspeeds here will be overridden\n");
   fprintf (pOut, "\n");
   fprintf (pOut, "# MIN/MAX_DELAY specifies the Reaction Time in Seconds\n");
   fprintf (pOut, "# AIM_OFFS_X/Y/Z are the offsets for aiming (note that HL uses\n");
   fprintf (pOut, "# the lefthanded coordinate system where Z is the Up Direction)\n");
   fprintf (pOut, "# HEADSHOT_ALLOW specifies (in percent) the probability of aiming\n");
   fprintf (pOut, "# at the Head. This doesn't mean he actually fires at your head\n");
   fprintf (pOut, "# but he is allowed to do so.\n");
   fprintf (pOut, "# HEAR_SHOOTHRU_PROB specifies (in percent) the probability of shooting\n");
   fprintf (pOut, "# through Obstacles if the Bot has heard someone, has a weapon to do so\n");
   fprintf (pOut, "# and has this enemy in his viewing cone.\n");
   fprintf (pOut, "# SEEN_SHOOTHRU_PROB specifies (in percent) the probability of shooting\n");
   fprintf (pOut, "# through Obstacles if the Bot has seen this enemy before, has a weapon\n");
   fprintf (pOut, "# to do so and this enemy is still in his viewing cone.\n");
   fprintf (pOut, "\n");
   fprintf (pOut, "# The order is from the Worst Bots to the Best. DON'T CHANGE THE\n");
   fprintf (pOut, "# ORDER IN THIS FILE UNLESS YOU WANT TO EXPERIENCE WEIRD THINGS!\n");
   fprintf (pOut, "\n");

   for (int i = 0; i < SKL_MAX; i++)
   {
      string sSkill = "0-19";

      switch (i)
      {
      case SKL0019:
         sSkill = "0-19";
         break;

      case SKL2039:
         sSkill = "20-39";
         break;

      case SKL4059:
         sSkill = "40-59";
         break;

      case SKL6079:
         sSkill = "60-79";
         break;

      case SKL8099:
         sSkill = "80-99";
         break;

      case SKL_100:
         sSkill = "100";
         break;
      }

      fprintf (pOut, "# Settings for Bots Skill %s\n", sSkill);
      fprintf (pOut, "%s %.1f\n", SKILL_MAX_DELAY, m_kSkillData[i].fMaxDelay >= 2 ? m_kSkillData[i].fMaxDelay / 100 : m_kSkillData[i].fMaxDelay);
      fprintf (pOut, "%s %.1f\n", SKILL_MIN_DELAY, m_kSkillData[i].fMinDelay >= 2 ? m_kSkillData[i].fMinDelay / 100 : m_kSkillData[i].fMinDelay);
      fprintf (pOut, "%s %d.0\n", SKILL_AIM_OFFS_X, static_cast <int> (m_kSkillData[i].fAimOffsX));
      fprintf (pOut, "%s %d.0\n", SKILL_AIM_OFFS_Y, static_cast <int> (m_kSkillData[i].fAimOffsY));
      fprintf (pOut, "%s %d.0\n", SKILL_AIM_OFFS_Z, static_cast <int> (m_kSkillData[i].fAimOffsZ));
      fprintf (pOut, "%s %d\n", SKILL_HEADSHOT_ALLOW, static_cast <int> (m_kSkillData[i].fHeadshot));
      fprintf (pOut, "%s %d\n", SKILL_HEARPROB, static_cast <int> (m_kSkillData[i].fHearProb));
      fprintf (pOut, "%s %d\n\n", SKILL_SEENPROB, static_cast <int> (m_kSkillData[i].fSeenProb));
   }
   fclose (pOut);
}
