//
// Yet Another Ping Of Death Bot Configuration Tool
// Copyright (c) 2005, by Dmitry Zhukov. All Rights Reserved.
//
// P.S.: I HATE BORLANDC C++ BUILDER IDE! :)
//


#ifndef CONF_PARSE_H
#define CONF_PARSE_H

enum eSkl
{
   SKL0019,
   SKL2039,
   SKL4059,
   SKL6079,
   SKL8099,
   SKL_100,
   SKL_MAX
};

typedef struct skillconf_s
{
   float fMinDelay;
   float fMaxDelay;
   float fAimOffsX;
   float fAimOffsY;
   float fAimOffsZ;
   float fHeadshot;
   float fHearProb;
   float fSeenProb;
} skillconf_t;

#define SKILL_MIN_DELAY "MIN_DELAY"
#define SKILL_MAX_DELAY "MAX_DELAY"
#define SKILL_AIM_OFFS_X "AIM_OFFS_X"
#define SKILL_AIM_OFFS_Y "AIM_OFFS_Y"
#define SKILL_AIM_OFFS_Z "AIM_OFFS_Z"
#define SKILL_HEADSHOT_ALLOW "HEADSHOT_ALLOW"
#define SKILL_HEARPROB "HEAR_SHOOTTHRU_PROB"
#define SKILL_SEENPROB "SEEN_SHOOTTHRU_PROB"

class CConfig
{
private:
   vector <string> m_kFileBuffer;

public:
   CConfig        (string sInputFile);
   ~CConfig       (void) { }

   void           SetString (string sName, string sValue);
   string         GetString (string sName);

   void           WriteOutput (bool bCleanOne = false, string sConfigName = "podbot.cfg");

   // misc utils
   template <typename T> T GetValue (string sName) { return (T) GetString (sName); }
   int            IsOn (string sName) { if (GetString (sName) == "666") return 2; else return GetValue <int> (sName) > 0; }
   int            IsOff (string sName) { return !IsOn (sName); }
   vector <string> GetData (void) { return m_kFileBuffer; }
   void           SetData (vector <string> kData) { m_kFileBuffer = kData; }
};

class CSkillConfig
{
private:
   skillconf_t    m_kSkillData[SKL_MAX];
   
public:
   CSkillConfig   (void);

   void           SetString (eSkl iAt, string sName, string sValue);
   string         GetString (eSkl iAt, string sName);
   void           SetIDE (eSkl iSkl);
   
   void           WriteConfig (void);
   skillconf_t   *Set (eSkl iSkl) { return &m_kSkillData[iSkl]; }
};

#endif